#ifndef _FKP_MOTIONCHARACTOR_H_HEADER_
#define _FKP_MOTIONCHARACTOR_H_HEADER_

#include <FK/FK.h>
// #include <FL/Fl_Multi_Browser.h>
#include "./MotionData.h"
// #include "./TimeLine.h"

/*
// pR}h`
enum fk_Poser_Operation {
	KF_INSERT = 0,
	KF_CHANGE = 1,
	KF_DELETE = 2
};
*/

class CMotionCharactor {
private:
	vector<fk_Model *>			jointModel;
	vector<fk_Shape *>			mesh;
	vector<fk_Model *>			objModel;

	vector<fk_Material>			matPalette;
	vector<int>					matTable;
	vector<fk_Image *>			texImage;
	vector<string>				texName;
	vector<int>					texTable;

	string						mqoName;
	int							objNum;
	vector<string>				objName;
	map<int, int>				parentTable;
	bool						parentConnect;

	// vector<fk_Vector>			orgPos;

	/*
	vector<CKeyFrameMotion>		keyFrameData;
	int							nowFrame, maxFrame;
	*/

	vector<vector<CKeyFrameMotion> >	keyFrameData;
	vector<int>							nowFrame, maxFrame;

	int			prevPlayMotionID, loopCnt;

	fk_Scene	*ref_scene;

	fk_Model	absParent;

	typedef map<int, int>::iterator parentIte;

	void init(void);
	bool enumObjectName(const string);

	/*
	// f[^x[X
	fk_History					history;
	bool						historyMode;
	// AhDEhD
	void						UndoCom(fk_Command *);
	void						RedoCom(fk_Command *);
	*/

public:
	CMotionCharactor(void);
	~CMotionCharactor(void);

	bool loadObjectData(const string);
	bool loadJointData(const string);
	// bool saveJointData(const string);
	bool loadMotionData(const string);
	// bool saveMotionData(const string);

	void entryScene(fk_Scene *);
	void removeScene(fk_Scene *);
	void setDrawMode(bool);

	// void setMarkerShape(fk_Shape *);

	int getObjectNum(void);
	// vector<string> * getNameArray(void);

	fk_Model * getBaseModel(void)
	{
		return &absParent;
	};
	fk_Model * getObjectModel(int);
	fk_Model * getJointModel(int);
	// map<int, int> * getParentTable(void);

	void jointToPoser(void);
	// void poserToJoint(void);

	/*
	int getNowFrame(void);
	int getTotalFrame(void);
	bool playMotion(void);
	void stillMotion(int);
	*/

	int getNowFrame(int);
	int getTotalFrame(int);
	bool playMotion(int);
	void stillMotion(int, int);

	void setNowFrame(int, int);
	bool isMotionFinished(int);
	int getLoopCount(void);

	/*
	void makeKeyFrame(int, int, fk_MotionInterType, int = -1);
	void changeKeyFrame(int, int, fk_MotionInterType, int);
	void deleteKeyFrame(int, int);

	void browseKeyFrame(Fl_Multi_Browser *, int);
	void refreshTimeLine(CTimeLine *, int);

	// 𑀍
	void setHistoryMode(bool);
	void setHistoryMark(void);
	bool undoHistory(void);
	bool redoHistory(void);
	*/

	// IuWFNgƂ̕\^\
	void objShowHide(int);
};

vector<string> fk_StrSplit(string, string);

// void POE_DiscardTextureCache(void);

#endif
